/* Autogenerated with kurento-module-creator */

#ifndef __MEDIA_ELEMENT_HPP__
#define __MEDIA_ELEMENT_HPP__

#include <jsoncpp/json/json.h>
#include <jsonrpc/JsonRpcException.hpp>
#include <memory>
#include <vector>
#include "MediaObject.hpp"

namespace kurento
{
class MediaElement;
} /* kurento */

namespace kurento
{
class JsonSerializer;
void Serialize (std::shared_ptr<kurento::MediaElement> &object, JsonSerializer &serializer);
}

namespace kurento
{
class MediaType;
class MediaSource;
class MediaSink;
class AudioCaps;
class VideoCaps;
} /* kurento */

namespace kurento
{
class MediaElement : public virtual MediaObject
{

public:
  MediaElement () {};
  virtual ~MediaElement () {};

  virtual std::vector<std::shared_ptr<MediaSource>> getMediaSrcs () = 0;
  virtual std::vector<std::shared_ptr<MediaSource>> getMediaSrcs (std::shared_ptr<MediaType> mediaType) = 0;
  virtual std::vector<std::shared_ptr<MediaSource>> getMediaSrcs (std::shared_ptr<MediaType> mediaType, const std::string &description) = 0;
  virtual std::vector<std::shared_ptr<MediaSink>> getMediaSinks () = 0;
  virtual std::vector<std::shared_ptr<MediaSink>> getMediaSinks (std::shared_ptr<MediaType> mediaType) = 0;
  virtual std::vector<std::shared_ptr<MediaSink>> getMediaSinks (std::shared_ptr<MediaType> mediaType, const std::string &description) = 0;
  virtual void connect (std::shared_ptr<MediaElement> sink) = 0;
  virtual void connect (std::shared_ptr<MediaElement> sink, std::shared_ptr<MediaType> mediaType) = 0;
  virtual void connect (std::shared_ptr<MediaElement> sink, std::shared_ptr<MediaType> mediaType, const std::string &mediaDescription) = 0;
  virtual void setAudioFormat (std::shared_ptr<AudioCaps> caps) = 0;
  virtual void setVideoFormat (std::shared_ptr<VideoCaps> caps) = 0;

  virtual std::string getType () const {
    return "MediaElement";
  }

  virtual std::string getModule () const {
    return "kurento";
  }

  virtual void Serialize (JsonSerializer &serializer) = 0;

};

} /* kurento */

#endif /*  __MEDIA_ELEMENT_HPP__ */
