# - Try to find KMSCORE library

#=============================================================================
# Copyright 2014 Kurento
#
#=============================================================================

set(PACKAGE_VERSION "5.0.4")
set(KMSCORE_VERSION ${PACKAGE_VERSION})

message (STATUS "Looking for KMSCORE: 5.0.4")

include (GenericFind)

set (REQUIRED_VARS
  KMSCORE_VERSION
  KMSCORE_INCLUDE_DIRS
  KMSCORE_LIBRARY
  KMSCORE_LIBRARIES
)

set(KMSCORE_INCLUDE_DIRS
)

if (NOT "MediaType.hpp FilterType.hpp VideoCodec.hpp AudioCodec.hpp Fraction.hpp AudioCaps.hpp VideoCaps.hpp MediaObject.hpp SessionEndpoint.hpp Hub.hpp Filter.hpp Endpoint.hpp HubPort.hpp UriEndpoint.hpp MediaPad.hpp MediaSource.hpp MediaPipeline.hpp MediaSink.hpp SdpEndpoint.hpp MediaElement.hpp Error.hpp MediaSessionTerminated.hpp MediaSessionStarted.hpp Media.hpp MediaObjectInternal.hpp SessionEndpointInternal.hpp HubInternal.hpp FilterInternal.hpp EndpointInternal.hpp HubPortInternal.hpp UriEndpointInternal.hpp MediaPadInternal.hpp MediaSourceInternal.hpp MediaPipelineInternal.hpp MediaSinkInternal.hpp SdpEndpointInternal.hpp MediaElementInternal.hpp" STREQUAL " ")
  find_path(KMSCORE_INTERFACE_INCLUDE_DIR
    NAMES
      MediaType.hpp FilterType.hpp VideoCodec.hpp AudioCodec.hpp Fraction.hpp AudioCaps.hpp VideoCaps.hpp MediaObject.hpp SessionEndpoint.hpp Hub.hpp Filter.hpp Endpoint.hpp HubPort.hpp UriEndpoint.hpp MediaPad.hpp MediaSource.hpp MediaPipeline.hpp MediaSink.hpp SdpEndpoint.hpp MediaElement.hpp Error.hpp MediaSessionTerminated.hpp MediaSessionStarted.hpp Media.hpp
      MediaObjectInternal.hpp SessionEndpointInternal.hpp HubInternal.hpp FilterInternal.hpp EndpointInternal.hpp HubPortInternal.hpp UriEndpointInternal.hpp MediaPadInternal.hpp MediaSourceInternal.hpp MediaPipelineInternal.hpp MediaSinkInternal.hpp SdpEndpointInternal.hpp MediaElementInternal.hpp
    PATH_SUFFIXES
      obj-x86_64-linux-gnu/src/server/interface/generated-cpp
      kurento/modules/core
  )

  list (APPEND KMSCORE_INCLUDE_DIRS ${KMSCORE_INTERFACE_INCLUDE_DIR})
  list (APPEND REQUIRED_VARS KMSCORE_INTERFACE_INCLUDE_DIR)
endif ()

if (NOT "MediaObjectImplFactory.hpp SessionEndpointImplFactory.hpp HubImplFactory.hpp FilterImplFactory.hpp EndpointImplFactory.hpp HubPortImplFactory.hpp UriEndpointImplFactory.hpp MediaPadImplFactory.hpp MediaSourceImplFactory.hpp MediaPipelineImplFactory.hpp MediaSinkImplFactory.hpp SdpEndpointImplFactory.hpp MediaElementImplFactory.hpp" STREQUAL "")
  find_path(KMSCORE_IMPLEMENTATION_INTERNAL_INCLUDE_DIR
    NAMES
      MediaObjectImplFactory.hpp SessionEndpointImplFactory.hpp HubImplFactory.hpp FilterImplFactory.hpp EndpointImplFactory.hpp HubPortImplFactory.hpp UriEndpointImplFactory.hpp MediaPadImplFactory.hpp MediaSourceImplFactory.hpp MediaPipelineImplFactory.hpp MediaSinkImplFactory.hpp SdpEndpointImplFactory.hpp MediaElementImplFactory.hpp
    PATH_SUFFIXES
      obj-x86_64-linux-gnu/src/server/implementation/generated-cpp
      kurento/modules/core
  )

  list (APPEND KMSCORE_INCLUDE_DIRS ${KMSCORE_IMPLEMENTATION_INTERNAL_INCLUDE_DIR})
  list (APPEND REQUIRED_VARS KMSCORE_IMPLEMENTATION_INTERNAL_INCLUDE_DIR)
endif ()

if (NOT "MediaObjectImpl.hpp SessionEndpointImpl.hpp HubImpl.hpp FilterImpl.hpp EndpointImpl.hpp HubPortImpl.hpp UriEndpointImpl.hpp MediaPadImpl.hpp MediaSourceImpl.hpp MediaPipelineImpl.hpp MediaSinkImpl.hpp SdpEndpointImpl.hpp MediaElementImpl.hpp" STREQUAL "")
  find_path(KMSCORE_IMPLEMENTATION_GENERATED_INCLUDE_DIR
    NAMES
      MediaObjectImpl.hpp SessionEndpointImpl.hpp HubImpl.hpp FilterImpl.hpp EndpointImpl.hpp HubPortImpl.hpp UriEndpointImpl.hpp MediaPadImpl.hpp MediaSourceImpl.hpp MediaPipelineImpl.hpp MediaSinkImpl.hpp SdpEndpointImpl.hpp MediaElementImpl.hpp
    PATH_SUFFIXES
      src/server/implementation/objects
      kurento/modules/core
  )

  list (APPEND KMSCORE_INCLUDE_DIRS ${KMSCORE_IMPLEMENTATION_GENERATED_INCLUDE_DIR})
  list (APPEND REQUIRED_VARS KMSCORE_IMPLEMENTATION_GENERATED_INCLUDE_DIR)
endif()

if (NOT "EventHandler.hpp Factory.hpp MediaSet.hpp FactoryRegistrar.hpp ModuleManager.hpp" STREQUAL "")
  find_path(KMSCORE_IMPLEMENTATION_EXTRA_INCLUDE_DIR
    NAMES
      EventHandler.hpp Factory.hpp MediaSet.hpp FactoryRegistrar.hpp ModuleManager.hpp
    PATH_SUFFIXES
      src/server/implementation
      kurento/modules/core
  )

  list (APPEND KMSCORE_INCLUDE_DIRS ${KMSCORE_IMPLEMENTATION_EXTRA_INCLUDE_DIR})
  list (APPEND REQUIRED_VARS KMSCORE_IMPLEMENTATION_EXTRA_INCLUDE_DIR)
endif ()

if (NOT "KurentoException.hpp" STREQUAL "")
  find_path(KMSCORE_INTERFACE_EXTRA_INCLUDE_DIR
    NAMES
      KurentoException.hpp
    PATH_SUFFIXES
      src/server/interface
      kurento/modules/core
  )

  list (APPEND KMSCORE_INCLUDE_DIRS ${KMSCORE_INTERFACE_EXTRA_INCLUDE_DIR})
  list (APPEND REQUIRED_VARS KMSCORE_INTERFACE_EXTRA_INCLUDE_DIR)
endif ()

find_library (KMSCORE_LIBRARY
  NAMES
    kmscoreimpl
  PATH_SUFFIXES
    build/src/server
)

set (REQUIRED_LIBS "gstreamer-1.0 ~1.4;gstreamer-sdp-1.0 ~1.4;KmsJsonRpc ^0.1.0;sigc++-2.0 ;glibmm-2.4 ")
foreach (LIB ${REQUIRED_LIBS})
  string(FIND ${LIB} " " POS)

  if (${POS} GREATER 0)
    string (SUBSTRING ${LIB} 0 ${POS} LIB_NAME)
    string (SUBSTRING ${LIB} ${POS} -1 LIB_VERSION)
    string (STRIP ${LIB_NAME} LIB_NAME)
    string (STRIP ${LIB_VERSION} LIB_VERSION)
    generic_find (LIBNAME ${LIB_NAME} REQUIRED VERSION "${LIB_VERSION}")
  else ()
    string (STRIP ${LIB} LIB_NAME)
    generic_find (LIBNAME ${LIB_NAME} REQUIRED)
  endif ()
  list (APPEND REQUIRED_LIBRARIES ${${LIB_NAME}_LIBRARIES})
  list (APPEND KMSCORE_INCLUDE_DIRS ${${LIB_NAME}_INCLUDE_DIRS})

endforeach()

set(KMSCORE_INCLUDE_DIRS
  ${KMSCORE_INCLUDE_DIRS}
  CACHE INTERNAL "Include directories for KMSCORE library"
)

set (KMSCORE_LIBRARIES
  ${KMSCORE_LIBRARY}
  ${REQUIRED_LIBRARIES}
  CACHE INTERNAL "Libraries for KMSCORE"
)

include (FindPackageHandleStandardArgs)

find_package_handle_standard_args(KMSCORE
  FOUND_VAR
    KMSCORE_FOUND
  REQUIRED_VARS
    ${REQUIRED_VARS}
  VERSION_VAR
    KMSCORE_VERSION
)

mark_as_advanced(
  KMSCORE_FOUND
  KMSCORE_VERSION
  KMSCORE_INTERFACE_INCLUDE_DIR
  KMSCORE_IMPLEMENTATION_INTERNAL_INCLUDE_DIR
  KMSCORE_IMPLEMENTATION_GENERATED_INCLUDE_DIR
  KMSCORE_IMPLEMENTATION_EXTRA_INCLUDE_DIR
  KMSCORE_INTERFACE_EXTRA_INCLUDE_DIR
  KMSCORE_INCLUDE_DIRS
  KMSCORE_LIBRARY
  KMSCORE_LIBRARIES
)
